# Copyright (c) 2022-2023 Arm Limited and/or its affiliates.
# <open-source-office@arm.com>
#
# SPDX-License-Identifier: MIT

Image-Build-{{ CI_JOB_NAME_SLUG }}:
{% if BUILD_HOST_ARCH == 'x86_64' %}
  tags:
    - x86_64
{% endif %}
  extends: .kas_build_cassini
  # Store the build artifacts from the job. The download urls of these artifacts are later used by lava jobs to download and test the image.
  variables:
    KAS_CONFIGS: "{{ CI_JOB_NAME }}"
  after_script:
    # Store build output data for test stages
    - pushd ${KAS_WORK_DIR}/build/tmp/deploy/images/{{ MACHINE }}
    - export IMAGE=$(ls -- *-{{ MACHINE }}.wic.bmap | sed "s/-{{ MACHINE }}\.wic\.bmap//")
    - echo "IMAGE=${IMAGE}" > ${CI_PROJECT_DIR}/build_data.env
    - echo "IMAGE = ${IMAGE}"
    - export ARTIFACT_DIR="$(realpath --relative-to=${CI_PROJECT_DIR} ${KAS_WORK_DIR})/build/tmp/deploy/images/{{ MACHINE }}"
    - echo "ARTIFACT_DIR=${ARTIFACT_DIR}" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "ARTIFACT_DIR = ${ARTIFACT_DIR}"
    - echo "IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${IMAGE}-{{ MACHINE }}.wic.gz)" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "BMAP_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${IMAGE}-{{ MACHINE }}.wic.bmap)" >> ${CI_PROJECT_DIR}/build_data.env
{% if MACHINE == 'n1sdp' %}
    - export FW_IMAGE=$(ls -- *-board-firmware_primary.tar.gz | sed "s/-board-firmware_primary\.tar\.gz//")
    - echo "FW_IMAGE=${FW_IMAGE}" >> ${CI_PROJECT_DIR}/build_data.env
{% elif MACHINE.startswith('corstone1000') %}
    - echo "BL1_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/bl1.bin" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "BL1_IMAGE=bl1.bin" >> ${CI_PROJECT_DIR}/build_data.env
    - |
      export UTIL_IMAGE=$(ls -- *-{{ MACHINE }}.tar.bz2 | sed "s/-{{ MACHINE }}\.tar\.bz2//")
      if [ -e ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2 ]; then
        echo "UTIL_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2)" >> ${CI_PROJECT_DIR}/build_data.env
        echo "UTIL_IMAGE=${UTIL_IMAGE}" >> ${CI_PROJECT_DIR}/build_data.env
      fi
    - export FW_IMAGE=$(ls -- corstone1000-image-{{ MACHINE }}.wic | sed "s/-{{ MACHINE }}\.wic//")
    - echo "FW_IMAGE=${FW_IMAGE}" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "FW_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${FW_IMAGE}-{{ MACHINE }}.wic)" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "EXTSYS_IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/es_flashfw.bin" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "EXTSYS_IMAGE=es_flashfw.bin" >> ${CI_PROJECT_DIR}/build_data.env
{% if MACHINE == 'corstone1000-fvp' %}
    - export FVP_CONFIG=$(ls -- *-{{ MACHINE }}.fvpconf | sed "s/-{{ MACHINE }}\.fvpconf//")
    - echo "FVP_CONFIG_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/work/build/tmp/deploy/images/{{ MACHINE }}/$(readlink ${FVP_CONFIG}-{{ MACHINE }}.fvpconf)" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "FVP_CONFIG=${FVP_CONFIG}" >> ${CI_PROJECT_DIR}/build_data.env
    - echo "IMAGE_ARTIFACT_URL=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/jobs/${CI_JOB_ID}/artifacts/${ARTIFACT_DIR}/$(readlink ${IMAGE}-{{ MACHINE }}.wic.pad.gz)" >> ${CI_PROJECT_DIR}/build_data.env
{% endif %}
{% endif %}
    # Store built images
    - |
      (
        flock --timeout 120 200
        rm -rf ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}
        mkdir --parents ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}
        cp $(readlink ${IMAGE}-{{ MACHINE }}.wic.gz) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${IMAGE}-{{ MACHINE }}.wic.gz
        cp $(readlink ${IMAGE}-{{ MACHINE }}.wic.bmap) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${IMAGE}-{{ MACHINE }}.wic.bmap
{% if MACHINE == 'n1sdp' %}
        cp ${FW_IMAGE}-board-firmware_primary.tar.gz ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${FW_IMAGE}-board-firmware_primary.tar.gz
{% elif MACHINE.startswith('corstone1000') %}
        cp bl1.bin ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/bl1.bin
        cp es_flashfw.bin ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/es_flashfw.bin
        cp $(readlink ${FW_IMAGE}-{{ MACHINE }}.wic) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${FW_IMAGE}-{{ MACHINE }}.wic
        if [ -e ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2 ]; then
          cp $(readlink ${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${UTIL_IMAGE}-{{ MACHINE }}.tar.bz2
        fi
{% if MACHINE == 'corstone1000-fvp' %}
        cp $(readlink ${FVP_CONFIG}-{{ MACHINE }}.fvpconf) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${FVP_CONFIG}-{{ MACHINE }}.fvpconf
        cp $(readlink ${IMAGE}-{{ MACHINE }}.wic.pad.gz) ${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}/${IMAGE}-{{ MACHINE }}.wic.pad.gz
{% endif %}
{% endif %}
      ) 200>${IMAGE_DIR}/{{ CI_JOB_NAME_SLUG }}.lock
    - popd # ${KAS_WORK_DIR}/build/tmp/deploy/images/{{ MACHINE }}
    - chmod 777 ${CI_PROJECT_DIR}/build_data.env
    - cat ${CI_PROJECT_DIR}/build_data.env
  artifacts:
    paths:
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic.gz
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic.bmap
{% if MACHINE == 'n1sdp' %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-board-firmware_primary.tar.gz
{% elif MACHINE.startswith('corstone1000')  %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/bl1.bin
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/es_flashfw.bin
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.tar.bz2
{% if MACHINE == 'corstone1000-fvp' %}
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.fvpconf
      - $KAS_WORK_DIR/build/tmp/deploy/images/{{ MACHINE }}/*-*-*.wic.pad.gz
{% endif %}
{% endif %}
      - build_data.env
    reports:
      dotenv: build_data.env
    expire_in: '1 days'
  # Shouldn't interrupt a build or the DL_DIR can become corrupt
  interruptible: false

{% if RUN_TESTS != 'none' %}

Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}:
  extends: .test-preparation
  needs:
    - Image-Build-{{ CI_JOB_NAME_SLUG }}
  variables:
    MACHINE: "{{ MACHINE }}"

{% set can_run = ('all' in RUN_TESTS or 'ptest' in RUN_TESTS.split(',')) %}
{% set force =  ('all' in FORCE_TESTS or 'ptest' in FORCE_TESTS.split(',')) %}
{% set should_run = true %}
{% if can_run and (should_run or force) %}
PTest-{{ CI_JOB_NAME_SLUG }}:
  extends: .ptest-tests
  needs:
    - Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}
{% if MACHINE == 'corstone1000-fvp' %}
    - Build-FVP-Docker-Image
{% endif %}
  variables:
    MACHINE: "{{ MACHINE }}"

PTest-{{ CI_JOB_NAME_SLUG }}-Complete:
  extends: .ptest-tests-results
  needs:
    - PTest-{{ CI_JOB_NAME_SLUG }}
{% endif %}

{% set can_run = ('all' in RUN_TESTS or 'sanity' in RUN_TESTS.split(',')) %}
{% set force = ('all' in FORCE_TESTS or 'sanity' in FORCE_TESTS.split(',')) %}
{% set should_run = true %}
{% if can_run and (should_run or force) %}
Sanity-Test-{{ CI_JOB_NAME_SLUG }}:
  extends: .sanity-test
  needs:
    - Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}
{% if MACHINE == 'corstone1000-fvp' %}
    - Build-FVP-Docker-Image
{% endif %}
  variables:
    MACHINE: "{{ MACHINE }}"

Sanity-Test-{{ CI_JOB_NAME_SLUG }}-Complete:
  extends: .sanity-test-results
  needs:
    - Sanity-Test-{{ CI_JOB_NAME_SLUG }}
{% endif %}

{% set can_run = ('all' in RUN_TESTS or 'acs' in RUN_TESTS.split(',')) %}
{% set force =  ('all' in FORCE_TESTS or 'acs' in FORCE_TESTS.split(',')) %}
{% set should_run = (CI_PIPELINE_SOURCE == "schedule" and MACHINE!="corstone1000-mps3" )%}
{% if can_run and (should_run or force) %}
{% for i in range(NUMBER_OF_SEQUENCE_FILES | int) %}
ACS-SCT{{ i + 1 }}-Test-{{ CI_JOB_NAME_SLUG }}:
  extends: .acs-test
  needs:
    - Lava-Test-Prep-{{ CI_JOB_NAME_SLUG }}
{% if MACHINE == 'corstone1000-fvp' %}
    - Build-FVP-Docker-Image
{% endif %}
  variables:
    MACHINE: "{{ MACHINE }}"
    SEQUENCE_FILE: "EBBR{{ i + 1 }}"

ACS-SCT{{ i + 1 }}-Test-{{ CI_JOB_NAME_SLUG }}-Complete:
  extends: .acs-test-results
  needs:
    - ACS-SCT{{ i + 1 }}-Test-{{ CI_JOB_NAME_SLUG }}
  variables:
    SEQUENCE_FILE: "EBBR{{ i + 1 }}"
{% endfor %}
{% endif %}

{% endif %}
